package com.czsj.account.domain;

import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.czsj.common.annotation.Excel;
import com.czsj.common.core.domain.BaseEntity;

/**
 * 会员证件信息对象 czsj_member_card
 * 
 * @author czsj
 * @date 2024-12-01
 */
public class CzsjMemberCard extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 证件ID */
    private Integer uid;

    /** 会员ID */
    @Excel(name = "会员ID")
    private Long memberUid;

    /** 证件类型 */
    @Excel(name = "证件类型")
    private String cardType;

    /** 证件号码 */
    @Excel(name = "证件号码")
    private String cardId;

    /** 有效标识，0有效，1失效 */
    private Integer delFlag;

    /** 创建人ID */
    @Excel(name = "创建人ID")
    private Long createUserId;

    /** 修改人ID */
    @Excel(name = "修改人ID")
    private Long updateUserId;

    public void setUid(Integer uid) 
    {
        this.uid = uid;
    }

    public Integer getUid() 
    {
        return uid;
    }
    public void setMemberUid(Long memberUid) 
    {
        this.memberUid = memberUid;
    }

    public Long getMemberUid() 
    {
        return memberUid;
    }
    public void setCardType(String cardType) 
    {
        this.cardType = cardType;
    }

    public String getCardType() 
    {
        return cardType;
    }
    public void setCardId(String cardId) 
    {
        this.cardId = cardId;
    }

    public String getCardId() 
    {
        return cardId;
    }
    public void setDelFlag(Integer delFlag) 
    {
        this.delFlag = delFlag;
    }

    public Integer getDelFlag() 
    {
        return delFlag;
    }
    public void setCreateUserId(Long createUserId) 
    {
        this.createUserId = createUserId;
    }

    public Long getCreateUserId() 
    {
        return createUserId;
    }
    public void setUpdateUserId(Long updateUserId) 
    {
        this.updateUserId = updateUserId;
    }

    public Long getUpdateUserId() 
    {
        return updateUserId;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("uid", getUid())
            .append("memberUid", getMemberUid())
            .append("cardType", getCardType())
            .append("cardId", getCardId())
            .append("createTime", getCreateTime())
            .append("updateTime", getUpdateTime())
            .append("delFlag", getDelFlag())
            .append("createUserId", getCreateUserId())
            .append("updateUserId", getUpdateUserId())
            .toString();
    }
}
