package com.czsj.account.domain;

import java.util.Date;
import com.fasterxml.jackson.annotation.JsonFormat;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import com.czsj.common.annotation.Excel;
import com.czsj.common.core.domain.BaseEntity;

/**
 * 会员微信粉丝对象 czsj_member_wx_fans
 * 
 * @author czsj
 * @date 2024-12-01
 */
public class CzsjMemberWxFans extends BaseEntity
{
    private static final long serialVersionUID = 1L;

    /** 会员微信粉丝ID */
    private Long uid;

    /** 会员ID */
    @Excel(name = "会员ID")
    private Long memberUid;

    /** 公众号ID */
    @Excel(name = "公众号ID")
    private String appId;

    /** 公众号名称 */
    @Excel(name = "公众号名称")
    private String appName;

    /** 绑定时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "绑定时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date bindTime;

    /** 微信昵称 */
    @Excel(name = "微信昵称")
    private String name;

    /** 微信头像URL */
    @Excel(name = "微信头像URL")
    private String imageUrl;

    /** 微信unionID */
    @Excel(name = "微信unionID")
    private String unionId;

    /** 微信openID */
    @Excel(name = "微信openID")
    private String openId;

    /** 订阅状态，0订阅，1未订阅 */
    @Excel(name = "订阅状态，0订阅，1未订阅")
    private Integer subscribeStatus;

    /** 订阅时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "订阅时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date subscribeTime;

    /** 取消订阅时间 */
    @JsonFormat(pattern = "yyyy-MM-dd")
    @Excel(name = "取消订阅时间", width = 30, dateFormat = "yyyy-MM-dd")
    private Date unsubscribeTime;

    /** 有效标识，0有效，1无效 */
    private Integer delFlag;

    /** 创建人ID */
    @Excel(name = "创建人ID")
    private Long createUserId;

    /** 修改人ID */
    @Excel(name = "修改人ID")
    private Long updateUserId;

    public void setUid(Long uid) 
    {
        this.uid = uid;
    }

    public Long getUid() 
    {
        return uid;
    }
    public void setMemberUid(Long memberUid) 
    {
        this.memberUid = memberUid;
    }

    public Long getMemberUid() 
    {
        return memberUid;
    }
    public void setAppId(String appId) 
    {
        this.appId = appId;
    }

    public String getAppId() 
    {
        return appId;
    }
    public void setAppName(String appName) 
    {
        this.appName = appName;
    }

    public String getAppName() 
    {
        return appName;
    }
    public void setBindTime(Date bindTime) 
    {
        this.bindTime = bindTime;
    }

    public Date getBindTime() 
    {
        return bindTime;
    }
    public void setName(String name) 
    {
        this.name = name;
    }

    public String getName() 
    {
        return name;
    }
    public void setImageUrl(String imageUrl) 
    {
        this.imageUrl = imageUrl;
    }

    public String getImageUrl() 
    {
        return imageUrl;
    }
    public void setUnionId(String unionId) 
    {
        this.unionId = unionId;
    }

    public String getUnionId() 
    {
        return unionId;
    }
    public void setOpenId(String openId) 
    {
        this.openId = openId;
    }

    public String getOpenId() 
    {
        return openId;
    }
    public void setSubscribeStatus(Integer subscribeStatus) 
    {
        this.subscribeStatus = subscribeStatus;
    }

    public Integer getSubscribeStatus() 
    {
        return subscribeStatus;
    }
    public void setSubscribeTime(Date subscribeTime) 
    {
        this.subscribeTime = subscribeTime;
    }

    public Date getSubscribeTime() 
    {
        return subscribeTime;
    }
    public void setUnsubscribeTime(Date unsubscribeTime) 
    {
        this.unsubscribeTime = unsubscribeTime;
    }

    public Date getUnsubscribeTime() 
    {
        return unsubscribeTime;
    }
    public void setDelFlag(Integer delFlag) 
    {
        this.delFlag = delFlag;
    }

    public Integer getDelFlag() 
    {
        return delFlag;
    }
    public void setCreateUserId(Long createUserId) 
    {
        this.createUserId = createUserId;
    }

    public Long getCreateUserId() 
    {
        return createUserId;
    }
    public void setUpdateUserId(Long updateUserId) 
    {
        this.updateUserId = updateUserId;
    }

    public Long getUpdateUserId() 
    {
        return updateUserId;
    }

    @Override
    public String toString() {
        return new ToStringBuilder(this,ToStringStyle.MULTI_LINE_STYLE)
            .append("uid", getUid())
            .append("memberUid", getMemberUid())
            .append("appId", getAppId())
            .append("appName", getAppName())
            .append("bindTime", getBindTime())
            .append("name", getName())
            .append("imageUrl", getImageUrl())
            .append("unionId", getUnionId())
            .append("openId", getOpenId())
            .append("subscribeStatus", getSubscribeStatus())
            .append("subscribeTime", getSubscribeTime())
            .append("unsubscribeTime", getUnsubscribeTime())
            .append("createTime", getCreateTime())
            .append("updateTime", getUpdateTime())
            .append("delFlag", getDelFlag())
            .append("createUserId", getCreateUserId())
            .append("updateUserId", getUpdateUserId())
            .toString();
    }
}
