package com.czsj.account.mapper;

import java.util.List;
import com.czsj.account.domain.CzsjMemberLocus;

/**
 * 会员轨迹信息Mapper接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface CzsjMemberLocusMapper 
{
    /**
     * 查询会员轨迹信息
     * 
     * @param uid 会员轨迹信息主键
     * @return 会员轨迹信息
     */
    public CzsjMemberLocus selectCzsjMemberLocusByUid(Long uid);

    /**
     * 查询会员轨迹信息列表
     * 
     * @param czsjMemberLocus 会员轨迹信息
     * @return 会员轨迹信息集合
     */
    public List<CzsjMemberLocus> selectCzsjMemberLocusList(CzsjMemberLocus czsjMemberLocus);

    /**
     * 新增会员轨迹信息
     * 
     * @param czsjMemberLocus 会员轨迹信息
     * @return 结果
     */
    public int insertCzsjMemberLocus(CzsjMemberLocus czsjMemberLocus);

    /**
     * 修改会员轨迹信息
     * 
     * @param czsjMemberLocus 会员轨迹信息
     * @return 结果
     */
    public int updateCzsjMemberLocus(CzsjMemberLocus czsjMemberLocus);

    /**
     * 删除会员轨迹信息
     * 
     * @param uid 会员轨迹信息主键
     * @return 结果
     */
    public int deleteCzsjMemberLocusByUid(Long uid);

    /**
     * 批量删除会员轨迹信息
     * 
     * @param uids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCzsjMemberLocusByUids(Long[] uids);
}
