package com.czsj.account.mapper;

import java.util.List;
import com.czsj.account.domain.CzsjMemberRelation;

/**
 * 会员关系Mapper接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface CzsjMemberRelationMapper 
{
    /**
     * 查询会员关系
     * 
     * @param uid 会员关系主键
     * @return 会员关系
     */
    public CzsjMemberRelation selectCzsjMemberRelationByUid(Long uid);

    /**
     * 查询会员关系列表
     * 
     * @param czsjMemberRelation 会员关系
     * @return 会员关系集合
     */
    public List<CzsjMemberRelation> selectCzsjMemberRelationList(CzsjMemberRelation czsjMemberRelation);

    /**
     * 新增会员关系
     * 
     * @param czsjMemberRelation 会员关系
     * @return 结果
     */
    public int insertCzsjMemberRelation(CzsjMemberRelation czsjMemberRelation);

    /**
     * 修改会员关系
     * 
     * @param czsjMemberRelation 会员关系
     * @return 结果
     */
    public int updateCzsjMemberRelation(CzsjMemberRelation czsjMemberRelation);

    /**
     * 删除会员关系
     * 
     * @param uid 会员关系主键
     * @return 结果
     */
    public int deleteCzsjMemberRelationByUid(Long uid);

    /**
     * 批量删除会员关系
     * 
     * @param uids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCzsjMemberRelationByUids(Long[] uids);
}
