package com.czsj.account.mapper;

import java.util.List;
import com.czsj.account.domain.CzsjMemberWxSource;

/**
 * 会员微信来源信息Mapper接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface CzsjMemberWxSourceMapper 
{
    /**
     * 查询会员微信来源信息
     * 
     * @param uid 会员微信来源信息主键
     * @return 会员微信来源信息
     */
    public CzsjMemberWxSource selectCzsjMemberWxSourceByUid(Long uid);

    /**
     * 查询会员微信来源信息列表
     * 
     * @param czsjMemberWxSource 会员微信来源信息
     * @return 会员微信来源信息集合
     */
    public List<CzsjMemberWxSource> selectCzsjMemberWxSourceList(CzsjMemberWxSource czsjMemberWxSource);

    /**
     * 新增会员微信来源信息
     * 
     * @param czsjMemberWxSource 会员微信来源信息
     * @return 结果
     */
    public int insertCzsjMemberWxSource(CzsjMemberWxSource czsjMemberWxSource);

    /**
     * 修改会员微信来源信息
     * 
     * @param czsjMemberWxSource 会员微信来源信息
     * @return 结果
     */
    public int updateCzsjMemberWxSource(CzsjMemberWxSource czsjMemberWxSource);

    /**
     * 删除会员微信来源信息
     * 
     * @param uid 会员微信来源信息主键
     * @return 结果
     */
    public int deleteCzsjMemberWxSourceByUid(Long uid);

    /**
     * 批量删除会员微信来源信息
     * 
     * @param uids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteCzsjMemberWxSourceByUids(Long[] uids);
}
