package com.czsj.account.service;

import java.util.List;
import com.czsj.account.domain.CzsjMemberCard;

/**
 * 会员证件信息Service接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface ICzsjMemberCardService 
{
    /**
     * 查询会员证件信息
     * 
     * @param uid 会员证件信息主键
     * @return 会员证件信息
     */
    public CzsjMemberCard selectCzsjMemberCardByUid(Integer uid);

    /**
     * 查询会员证件信息列表
     * 
     * @param czsjMemberCard 会员证件信息
     * @return 会员证件信息集合
     */
    public List<CzsjMemberCard> selectCzsjMemberCardList(CzsjMemberCard czsjMemberCard);

    /**
     * 新增会员证件信息
     * 
     * @param czsjMemberCard 会员证件信息
     * @return 结果
     */
    public int insertCzsjMemberCard(CzsjMemberCard czsjMemberCard);

    /**
     * 修改会员证件信息
     * 
     * @param czsjMemberCard 会员证件信息
     * @return 结果
     */
    public int updateCzsjMemberCard(CzsjMemberCard czsjMemberCard);

    /**
     * 批量删除会员证件信息
     * 
     * @param uids 需要删除的会员证件信息主键集合
     * @return 结果
     */
    public int deleteCzsjMemberCardByUids(Integer[] uids);

    /**
     * 删除会员证件信息信息
     * 
     * @param uid 会员证件信息主键
     * @return 结果
     */
    public int deleteCzsjMemberCardByUid(Integer uid);
}
