package com.czsj.account.service;

import java.util.List;
import com.czsj.account.domain.CzsjMember;

/**
 * 会员信息Service接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface ICzsjMemberService 
{
    /**
     * 查询会员信息
     * 
     * @param uid 会员信息主键
     * @return 会员信息
     */
    public CzsjMember selectCzsjMemberByUid(Long uid);

    /**
     * 查询会员信息列表
     * 
     * @param czsjMember 会员信息
     * @return 会员信息集合
     */
    public List<CzsjMember> selectCzsjMemberList(CzsjMember czsjMember);

    /**
     * 新增会员信息
     * 
     * @param czsjMember 会员信息
     * @return 结果
     */
    public int insertCzsjMember(CzsjMember czsjMember);

    /**
     * 修改会员信息
     * 
     * @param czsjMember 会员信息
     * @return 结果
     */
    public int updateCzsjMember(CzsjMember czsjMember);

    /**
     * 批量删除会员信息
     * 
     * @param uids 需要删除的会员信息主键集合
     * @return 结果
     */
    public int deleteCzsjMemberByUids(Long[] uids);

    /**
     * 删除会员信息信息
     * 
     * @param uid 会员信息主键
     * @return 结果
     */
    public int deleteCzsjMemberByUid(Long uid);
}
