package com.czsj.account.service;

import java.util.List;
import com.czsj.account.domain.CzsjMemberTagGroup;

/**
 * 会员标签组Service接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface ICzsjMemberTagGroupService 
{
    /**
     * 查询会员标签组
     * 
     * @param uid 会员标签组主键
     * @return 会员标签组
     */
    public CzsjMemberTagGroup selectCzsjMemberTagGroupByUid(Long uid);

    /**
     * 查询会员标签组列表
     * 
     * @param czsjMemberTagGroup 会员标签组
     * @return 会员标签组集合
     */
    public List<CzsjMemberTagGroup> selectCzsjMemberTagGroupList(CzsjMemberTagGroup czsjMemberTagGroup);

    /**
     * 新增会员标签组
     * 
     * @param czsjMemberTagGroup 会员标签组
     * @return 结果
     */
    public int insertCzsjMemberTagGroup(CzsjMemberTagGroup czsjMemberTagGroup);

    /**
     * 修改会员标签组
     * 
     * @param czsjMemberTagGroup 会员标签组
     * @return 结果
     */
    public int updateCzsjMemberTagGroup(CzsjMemberTagGroup czsjMemberTagGroup);

    /**
     * 批量删除会员标签组
     * 
     * @param uids 需要删除的会员标签组主键集合
     * @return 结果
     */
    public int deleteCzsjMemberTagGroupByUids(Long[] uids);

    /**
     * 删除会员标签组信息
     * 
     * @param uid 会员标签组主键
     * @return 结果
     */
    public int deleteCzsjMemberTagGroupByUid(Long uid);
}
