package com.czsj.account.service;

import java.util.List;
import com.czsj.account.domain.CzsjMemberTag;

/**
 * 会员标签Service接口
 * 
 * @author czsj
 * @date 2024-12-01
 */
public interface ICzsjMemberTagService 
{
    /**
     * 查询会员标签
     * 
     * @param uid 会员标签主键
     * @return 会员标签
     */
    public CzsjMemberTag selectCzsjMemberTagByUid(Long uid);

    /**
     * 查询会员标签列表
     * 
     * @param czsjMemberTag 会员标签
     * @return 会员标签集合
     */
    public List<CzsjMemberTag> selectCzsjMemberTagList(CzsjMemberTag czsjMemberTag);

    /**
     * 新增会员标签
     * 
     * @param czsjMemberTag 会员标签
     * @return 结果
     */
    public int insertCzsjMemberTag(CzsjMemberTag czsjMemberTag);

    /**
     * 修改会员标签
     * 
     * @param czsjMemberTag 会员标签
     * @return 结果
     */
    public int updateCzsjMemberTag(CzsjMemberTag czsjMemberTag);

    /**
     * 批量删除会员标签
     * 
     * @param uids 需要删除的会员标签主键集合
     * @return 结果
     */
    public int deleteCzsjMemberTagByUids(Long[] uids);

    /**
     * 删除会员标签信息
     * 
     * @param uid 会员标签主键
     * @return 结果
     */
    public int deleteCzsjMemberTagByUid(Long uid);
}
