package com.czsj.account.service.impl;

import java.util.List;
import com.czsj.common.utils.DateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.czsj.account.mapper.CzsjMemberWxFansMapper;
import com.czsj.account.domain.CzsjMemberWxFans;
import com.czsj.account.service.ICzsjMemberWxFansService;

/**
 * 会员微信粉丝Service业务层处理
 * 
 * @author czsj
 * @date 2024-12-01
 */
@Service
public class CzsjMemberWxFansServiceImpl implements ICzsjMemberWxFansService 
{
    @Autowired
    private CzsjMemberWxFansMapper czsjMemberWxFansMapper;

    /**
     * 查询会员微信粉丝
     * 
     * @param uid 会员微信粉丝主键
     * @return 会员微信粉丝
     */
    @Override
    public CzsjMemberWxFans selectCzsjMemberWxFansByUid(Long uid)
    {
        return czsjMemberWxFansMapper.selectCzsjMemberWxFansByUid(uid);
    }

    /**
     * 查询会员微信粉丝列表
     * 
     * @param czsjMemberWxFans 会员微信粉丝
     * @return 会员微信粉丝
     */
    @Override
    public List<CzsjMemberWxFans> selectCzsjMemberWxFansList(CzsjMemberWxFans czsjMemberWxFans)
    {
        return czsjMemberWxFansMapper.selectCzsjMemberWxFansList(czsjMemberWxFans);
    }

    /**
     * 新增会员微信粉丝
     * 
     * @param czsjMemberWxFans 会员微信粉丝
     * @return 结果
     */
    @Override
    public int insertCzsjMemberWxFans(CzsjMemberWxFans czsjMemberWxFans)
    {
        czsjMemberWxFans.setCreateTime(DateUtils.getNowDate());
        return czsjMemberWxFansMapper.insertCzsjMemberWxFans(czsjMemberWxFans);
    }

    /**
     * 修改会员微信粉丝
     * 
     * @param czsjMemberWxFans 会员微信粉丝
     * @return 结果
     */
    @Override
    public int updateCzsjMemberWxFans(CzsjMemberWxFans czsjMemberWxFans)
    {
        czsjMemberWxFans.setUpdateTime(DateUtils.getNowDate());
        return czsjMemberWxFansMapper.updateCzsjMemberWxFans(czsjMemberWxFans);
    }

    /**
     * 批量删除会员微信粉丝
     * 
     * @param uids 需要删除的会员微信粉丝主键
     * @return 结果
     */
    @Override
    public int deleteCzsjMemberWxFansByUids(Long[] uids)
    {
        return czsjMemberWxFansMapper.deleteCzsjMemberWxFansByUids(uids);
    }

    /**
     * 删除会员微信粉丝信息
     * 
     * @param uid 会员微信粉丝主键
     * @return 结果
     */
    @Override
    public int deleteCzsjMemberWxFansByUid(Long uid)
    {
        return czsjMemberWxFansMapper.deleteCzsjMemberWxFansByUid(uid);
    }
}
